/*
 * Dinu Marian-Alexandru
 * 334 CC
 */ 

#define F_CPU 16000000

#include <avr/io.h>
#include <util/delay.h>

#define INIT				\
{							\
	DDRA = 0xFF;			\
	DDRC = 0xFF;			\
							\
	DDRD = 0;				\
	DDRD |= (1 << PD5);		\
	DDRD |= (1 << PD6);		\
							\
	DDRB = 0;				\
	PORTB |= (1 << PB0);	\
	PORTB |= (1 << PB1);	\
							\
	PORTD |= (1 << PD0);	\
	PORTD |= (1 << PD1);	\
	PORTD |= (1 << PD4);	\
							\
	TURN_OFF_RED_7;			\
}

/* top line */
#define BLUE_1 (1 << PC4)
#define BLUE_2 (1 << PC2)
#define BLUE_3 (1 << PC0)
#define RED_1 (1 << PC5)
#define RED_2 (1 << PC3)
#define RED_3 (1 << PC1)

/* middle line */
#define BLUE_4 (1 << PA5)
#define BLUE_5 (1 << PA7)
#define BLUE_6 (1 << PC6)
#define RED_4 (1 << PA4)
#define RED_5 (1 << PA6)
#define RED_6 (1 << PC7)

/* bottom line */
#define BLUE_7 (1 << PD5)
#define BLUE_8 (1 << PA1)
#define BLUE_9 (1 << PA3)
#define RED_7 (1 << PD6)
#define RED_8 (1 << PA0)
#define RED_9 (1 << PA2)


/* turn on red / BLUE LED */
#define TURN_ON_RED_1 PORTC |= RED_1
#define TURN_ON_RED_2 PORTC |= RED_2
#define TURN_ON_RED_3 PORTC |= RED_3
#define TURN_ON_RED_4 PORTA |= RED_4
#define TURN_ON_RED_5 PORTA |= RED_5
#define TURN_ON_RED_6 PORTC |= RED_6
#define TURN_ON_RED_7 PORTD |= RED_7
#define TURN_ON_RED_8 PORTA |= RED_8
#define TURN_ON_RED_9 PORTA |= RED_9

#define TURN_ON_BLUE_1 PORTC |= BLUE_1
#define TURN_ON_BLUE_2 PORTC |= BLUE_2
#define TURN_ON_BLUE_3 PORTC |= BLUE_3
#define TURN_ON_BLUE_4 PORTA |= BLUE_4
#define TURN_ON_BLUE_5 PORTA |= BLUE_5
#define TURN_ON_BLUE_6 PORTC |= BLUE_6
#define TURN_ON_BLUE_7 PORTD |= BLUE_7
#define TURN_ON_BLUE_8 PORTA |= BLUE_8
#define TURN_ON_BLUE_9 PORTA |= BLUE_9


/* turn off red / BLUE LED */
#define TURN_OFF_RED_1 PORTC &= ~RED_1
#define TURN_OFF_RED_2 PORTC &= ~RED_2
#define TURN_OFF_RED_3 PORTC &= ~RED_3
#define TURN_OFF_RED_4 PORTA &= ~RED_4
#define TURN_OFF_RED_5 PORTA &= ~RED_5
#define TURN_OFF_RED_6 PORTC &= ~RED_6
#define TURN_OFF_RED_7 PORTD &= ~RED_7
#define TURN_OFF_RED_8 PORTA &= ~RED_8
#define TURN_OFF_RED_9 PORTA &= ~RED_9

#define TURN_OFF_BLUE_1 PORTC &= ~BLUE_1
#define TURN_OFF_BLUE_2 PORTC &= ~BLUE_2
#define TURN_OFF_BLUE_3 PORTC &= ~BLUE_3
#define TURN_OFF_BLUE_4 PORTA &= ~BLUE_4
#define TURN_OFF_BLUE_5 PORTA &= ~BLUE_5
#define TURN_OFF_BLUE_6 PORTC &= ~BLUE_6
#define TURN_OFF_BLUE_7 PORTD &= ~BLUE_7
#define TURN_OFF_BLUE_8 PORTA &= ~BLUE_8
#define TURN_OFF_BLUE_9 PORTA &= ~BLUE_9


/* turn on individual red / BLUE LED */
#define TURN_ON_RED(led)				\
{										\
	switch(led)							\
	{									\
		case 1 : TURN_ON_RED_1; break;	\
		case 2 : TURN_ON_RED_2; break;	\
		case 3 : TURN_ON_RED_3; break;	\
		case 4 : TURN_ON_RED_4; break;	\
		case 5 : TURN_ON_RED_5; break;	\
		case 6 : TURN_ON_RED_6; break;	\
		case 7 : TURN_ON_RED_7; break;	\
		case 8 : TURN_ON_RED_8; break;	\
		case 9 : TURN_ON_RED_9; break;	\
	}									\
}

#define TURN_ON_BLUE(led)				\
{										\
	switch(led)							\
	{									\
		case 1 : TURN_ON_BLUE_1; break;	\
		case 2 : TURN_ON_BLUE_2; break;	\
		case 3 : TURN_ON_BLUE_3; break;	\
		case 4 : TURN_ON_BLUE_4; break;	\
		case 5 : TURN_ON_BLUE_5; break;	\
		case 6 : TURN_ON_BLUE_6; break;	\
		case 7 : TURN_ON_BLUE_7; break;	\
		case 8 : TURN_ON_BLUE_8; break;	\
		case 9 : TURN_ON_BLUE_9; break;	\
	}									\
}


/* turn on all red / BLUE LEDs */
#define TURN_ON_ALL_RED		\
{							\
	TURN_ON_RED_1;			\
	TURN_ON_RED_2;			\
	TURN_ON_RED_3;			\
	TURN_ON_RED_4;			\
	TURN_ON_RED_5;			\
	TURN_ON_RED_6;			\
	TURN_ON_RED_7;			\
	TURN_ON_RED_8;			\
	TURN_ON_RED_9;			\
}

#define TURN_ON_ALL_BLUE		\
{							\
	TURN_ON_BLUE_1;			\
	TURN_ON_BLUE_2;			\
	TURN_ON_BLUE_3;			\
	TURN_ON_BLUE_4;			\
	TURN_ON_BLUE_5;			\
	TURN_ON_BLUE_6;			\
	TURN_ON_BLUE_7;			\
	TURN_ON_BLUE_8;			\
	TURN_ON_BLUE_9;			\
}


/* turn off all red / BLUE LEDs */
#define TURN_OFF_ALL_RED		\
{								\
	TURN_OFF_RED_1;				\
	TURN_OFF_RED_2;				\
	TURN_OFF_RED_3;				\
	TURN_OFF_RED_4;				\
	TURN_OFF_RED_5;				\
	TURN_OFF_RED_6;				\
	TURN_OFF_RED_7;				\
	TURN_OFF_RED_8;				\
	TURN_OFF_RED_9;				\
}

#define TURN_OFF_ALL_BLUE		\
{								\
	TURN_OFF_BLUE_1;				\
	TURN_OFF_BLUE_2;				\
	TURN_OFF_BLUE_3;				\
	TURN_OFF_BLUE_4;				\
	TURN_OFF_BLUE_5;				\
	TURN_OFF_BLUE_6;				\
	TURN_OFF_BLUE_7;				\
	TURN_OFF_BLUE_8;				\
	TURN_OFF_BLUE_9;				\
}


/* turn on everything */
#define TURN_ON_ALL		\
{						\
	TURN_ON_ALL_RED;	\
	TURN_ON_ALL_BLUE;	\
}


/* turn off everything */
#define TURN_OFF_ALL	\
{						\
	TURN_OFF_ALL_RED;	\
	TURN_OFF_ALL_BLUE;	\
}


/* buttons */
#define MOVE_UP_PRESSED		\
	!(PINB & (1 << PB1))

#define MOVE_DOWN_PRESSED	\
	!(PINB & (1 << PB0))

#define MOVE_LEFT_PRESSED	\
	!(PIND & (1 << PD0))

#define MOVE_RIGHT_PRESSED	\
	!(PIND & (1 << PB4))

#define SELECT_PRESSED		\
	!(PIND & (1 << PD1))


/* other mini - utils */
#define RED 1
#define BLUE 2

typedef char BOOL;
#define TRUE  1
#define FALSE 0

#define MOVE_UP    1
#define MOVE_DOWN  2
#define MOVE_LEFT  3
#define MOVE_RIGHT 4
#define SELECT     5

/*
 * Returns true if any button has been pressed, false otherwise
 * Parameter will contain the actual button that was pressed
 */
BOOL ButtonPressed(char* button)
{
	if (MOVE_UP_PRESSED)
	{
		*button = MOVE_UP;
		return TRUE;
	}

	if (MOVE_DOWN_PRESSED)
	{
		*button = MOVE_DOWN;
		return TRUE;
	}

	if (MOVE_LEFT_PRESSED)
	{
		*button = MOVE_LEFT;
		return TRUE;
	}

	if (MOVE_RIGHT_PRESSED)
	{
		*button = MOVE_RIGHT;
		return TRUE;
	}

	if (SELECT_PRESSED)
	{
		*button = SELECT;
		return TRUE;
	}

	return FALSE;
}

/* sleep */
#define sleep(ms) _delay_ms(ms)

/************************************************************************/
/*                                                                      */
/************************************************************************/


/*
 * Bits 0 to 8 correspond to LEDs
 * 1 means LED is ON
 * 0 means LED is OFF
 */
char red[10];
char blue[10];

int pos = 5;

int moves = 0;

char player = RED;

/* reset variables */
#define RESET_POS pos = 5

#define RESET					\
{								\
	int i;						\
	for (i = 0; i < 10; ++i)	\
	{							\
		red[i] = 0;				\
		blue[i] = 0;				\
	}							\
								\
	moves = 0;					\
								\
	RESET_POS;					\
}


/* tests if led is red */
BOOL IsRedOn(int led)
{
	return red[led];
}


/* tests if led is BLUE */
BOOL IsBLUEOn(int led)
{
	return blue[led];
}


void UpdateLEDs()
{
	int i;

	TURN_OFF_ALL;

	if (player == RED)
		TURN_ON_RED(pos)
	else
		TURN_ON_BLUE(pos)

	for (i = 1; i < 10; ++i)
	{
		if (IsRedOn(i))
			TURN_ON_RED(i)

		if (IsBLUEOn(i))
			TURN_ON_BLUE(i)
	}
}


/* tests if current selection is ok */
#define IS_EMPTY ((IsRedOn(pos) == FALSE) && (IsBLUEOn(pos) == FALSE))


#define MAKE_RED_ON red[pos] = 1
#define MAKE_BLUE_ON blue[pos] = 1


void UpdateGame()
{
	static char buttonPressed;

	if (ButtonPressed(&buttonPressed) == TRUE)
	{
		sleep(250);

		switch(buttonPressed)
		{
			case MOVE_UP    : if (pos > 3) pos -= 3; break;
			case MOVE_DOWN  : if (pos < 7) pos += 3; break;
			case MOVE_LEFT  : if (pos % 3 != 1) pos -= 1; break;
			case MOVE_RIGHT : if (pos % 3 != 0) pos += 1; break;
			case SELECT :
			{
				if (IS_EMPTY)
				{
					++moves;

					if (player == RED)
					{
						MAKE_RED_ON;
						player = BLUE;
					}
					else
					{
						MAKE_BLUE_ON;
						player = RED;
					}
				}
			};
		}
	}
}


BOOL GameFinished(char* winner)
{
	if ((IsRedOn(1) && IsRedOn(2) && IsRedOn(3)) ||
		(IsRedOn(4) && IsRedOn(5) && IsRedOn(6)) ||
		(IsRedOn(7) && IsRedOn(8) && IsRedOn(9)) ||
		(IsRedOn(1) && IsRedOn(4) && IsRedOn(7)) ||
		(IsRedOn(2) && IsRedOn(5) && IsRedOn(8)) ||
		(IsRedOn(3) && IsRedOn(6) && IsRedOn(9)) ||
		(IsRedOn(1) && IsRedOn(5) && IsRedOn(9)) ||
		(IsRedOn(3) && IsRedOn(5) && IsRedOn(7)))
	{
		*winner = RED;
		return TRUE;
	}

	if ((IsBLUEOn(1) && IsBLUEOn(2) && IsBLUEOn(3)) ||
		(IsBLUEOn(4) && IsBLUEOn(5) && IsBLUEOn(6)) ||
		(IsBLUEOn(7) && IsBLUEOn(8) && IsBLUEOn(9)) ||
		(IsBLUEOn(1) && IsBLUEOn(4) && IsBLUEOn(7)) ||
		(IsBLUEOn(2) && IsBLUEOn(5) && IsBLUEOn(8)) ||
		(IsBLUEOn(3) && IsBLUEOn(6) && IsBLUEOn(9)) ||
		(IsBLUEOn(1) && IsBLUEOn(5) && IsBLUEOn(9)) ||
		(IsBLUEOn(3) && IsBLUEOn(5) && IsBLUEOn(7)))
	{
		*winner = BLUE;
		return TRUE;
	}

	if (moves == 9)
	{
		*winner = 0;
		return TRUE;
	}

	*winner = 0;
	return FALSE;
}


void PlayGame()
{
	static char winner;

	UpdateGame();
	UpdateLEDs();

	if (GameFinished(&winner))
	{
		sleep(1000);

		if (winner == RED)
			TURN_OFF_ALL_BLUE
		else
			TURN_OFF_ALL_RED

		sleep(1500);

		RESET;
	}
}


int main()
{
	INIT;

	while (1)
	{
		PlayGame();
	}

	return 0;
}